-- ******************************** Variables *******************************
local L = LibStub("AceLocale-3.0"):GetLocale("Titan", true)
local LB = LibStub("AceLocale-3.0"):GetLocale("TitanPals", true)
-- ******************************** Functions *******************************

-- **************************************************************************
-- NAME : TitanPanelPalsButton_SetTooltipText()
-- DESC : Build Firends Tooltip for Titan Panel
-- **************************************************************************
function TitanPanelPalsButton_SetTooltip()
     if ( TitanPals["UpDateDB"] == true ) then
          ShowFriends();
          TitanPanelPals_CoreUtils("UpDate", TitanPals["Faction"], TitanPals["Realm"], TitanPals["Player"]);
     else 
          GameTooltip:SetText(LB["TITAN_PALS_TOOLTIP"], HIGHLIGHT_FONT_COLOR.r, HIGHLIGHT_FONT_COLOR.g, HIGHLIGHT_FONT_COLOR.b);
          GameTooltip:AddLine(LB["TITAN_PALS_TOOLTIP_COMBAT"]);
          return;
     end
     GameTooltip:SetText(LB["TITAN_PALS_TOOLTIP"], HIGHLIGHT_FONT_COLOR.r, HIGHLIGHT_FONT_COLOR.g, HIGHLIGHT_FONT_COLOR.b);
     local np = GetNumFriends();
     local op = 0;
     local ofI, opn, opl, opc, opa, opco, ops, opno, tpcnp, tpai;
     if ( np == 0 ) then
          GameTooltip:AddLine(LB["TITAN_PALS_TOOLTIP_EMPTY"])
     else
          -- For showing online friends
          for ofI=1, np do
               opn, opl, opc, opa, opco, ops, opno = GetFriendInfo(ofI);
               if ( opco ) then
                    tpcnp = TitanPanelPals_CoreUtils("NamePlate", ops, opl, opc, opn);
                    tpai = opa;
                    op = op + 1;
                    if ( TitanPals["ShowNote"] ) then
                         if ( opno ) then opno = "("..opno..")"; tpai = TitanPanelPals_ColorUtils("GetCText", "hlight", opno).." "..tpai; end
                    end
                    GameTooltip:AddDoubleLine(tpcnp, tpai);
                    tpcnp = ""; tpai = "";
	       end
          end
          if ( op == 0 ) then GameTooltip:AddLine(LB["TITAN_PALS_TOOLTIP_NOPALS"]); end
          -- For showing offline friends  
          if ( TitanPals["ShowOffline"] ) then
               GameTooltip:AddLine("\n");
               GameTooltip:AddLine(TitanPanelPals_ColorUtils("GetCText", "hlight", LB["TITAN_PALS_TOOLTIP_OFF"]));
	       local fIndex = TitanPals["Lists"][TitanPals["palsDB"]];
	       local aIndex = TitanPals["Alts"][TitanPals["palsDB"]];
	       local lpl, lpc, lpno;
               for ofI=1, np do
                    opn, opl, opc, opa, opco, ops, opno = GetFriendInfo(ofI);
		    local lpl, lpc, lpno = string.match(fIndex[opn], '(.*):(.*):(.*)');
		    TitanPanelPals_DebugUtils("bug" ,"ShowOffline", " Level - "..lpl.." Class - "..lpc.." Note - "..lpno);
                    tpcnp = TitanPanelPals_CoreUtils("NamePlate", ops, lpl, lpc, opn);
                    tpai = "<Offline>"
                    if ( TitanPals["ShowNote"] and lpno ~= "na" ) then tpai = "("..lpno..")"..tpai end
                    if ( not opco ) then
                         if ( TitanPals["NoAlts"] and not aIndex[opn] ) then
                              GameTooltip:AddDoubleLine(tpcnp, TitanPanelPals_ColorUtils("GetCText", "gray", tpai));
                         elseif ( not TitanPals["NoAlts"] ) then 
                              GameTooltip:AddDoubleLine(tpcnp, TitanPanelPals_ColorUtils("GetCText", "gray", tpai));
                         end
                    end
               end
          end
	  -- For showing ignored ppl
          if ( TitanPals["ShowIgnored"] ) then
               GameTooltip:AddLine("\n");
               GameTooltip:AddLine(TitanPanelPals_ColorUtils("GetCText", "hlight", LB["TITAN_PALS_TOOLTIP_IGNORE"]));
               ni = GetNumIgnores();
               if ( ni == 0 ) then 
	            GameTooltip:AddLine(LB["TITAN_PALS_TOOLTIP_IGNORE_EMPTY"]);
               else
                    for ofI=1, ni do
                         local tpit = TitanPanelPals_ColorUtils("GetCText", "red", "<Ignored>");
                         GameTooltip:AddDoubleLine("  "..TitanPanelPals_ColorUtils("GetCText", "normal", GetIgnoreName(ofI)), tpit);
                    end
               end
          end
     end
     -- For showing AddOn memory Usage
     if ( TitanPals["ShowMem"] ) then
          GameTooltip:AddLine("\n");
          GameTooltip:AddLine(TitanPanelPals_ColorUtils("GetCText", "hlight", LB["TITAN_PALS_TOOLTIP_MEM"]));
	  GameTooltip:AddDoubleLine("Titan Panel [|cffeda55fPals|r]", TitanPanelPals_ColorUtils("GetCText", "green", floor(GetAddOnMemoryUsage('TitanPals')).."kb"))
     end
end

-- **************************************************************************
-- NAME : TitanPanelPals_FixPalsEcho()
-- DESC : <research>
-- **************************************************************************
function TitanPanelPals_FixPalsEcho(level, class, name)		
	local class = TitanPanelPals_ColorUtils("GetCClass", "color", class, class);
	local name = TitanPanelPals_ColorUtils("GetCClass", "color", class, name);
	return "Fixing Pals ["..name.."] Class = ["..class.."] Level = ["..TitanPanelPals_ColoredUtils("GetCText", "orange", level).."]";
end

-- **************************************************************************
-- NAME : TitanPalsUtils_FixPal()
-- DESC : <research>
-- **************************************************************************
function TitanPalsUtils_FixPal(PN, PC, PL)
	if ( PC == "1" ) then PC = "Warrior";
	elseif ( PC == "2" ) then PC = "Mage";
	elseif ( PC == "3" ) then PC = "Warlock";
	elseif ( PC == "4" ) then PC = "Paladin";
	elseif ( PC == "5" ) then PC = "Priest";
	elseif ( PC == "6" ) then PC = "Hunter";
	elseif ( PC == "7" ) then PC = "Shaman";
	elseif ( PC == "8" ) then PC = "Rogue";
	elseif ( PC == "9" ) then PC = "Druid";
	elseif ( PC == "10" ) then PC = "Death Knight"; end
	local printLine = TitanPanelPals_FixPalsEcho(PL, PC, PN);
	TitanPanelPals_DebugUtils("bug", "FxiPals", printLine);
	local TPF = UnitFactionGroup("player");
	local TPR = GetCVar("realmName");
	local TPRU = GetUnitName("player");
	TitanPals["Lists"][TitanPals["palsDB"]][PN].class = PC;
	TitanPals["Lists"][TitanPals["palsDB"]][PN].level = PL;
end